<?php
/*
Plugin Name: Buscapé Everywhere
Plugin URI: http://www.tecnocracia.com.br/arquivos/buscape
Description: Conjunto de opções para turbinar seu Afiliados Buscapé com Wordpress.
Version: 1.1
Date: Mar 20th, 2007
Author: Manoel Netto
Author URI: http://www.tecnocracia.com.br
*/ 

/* 
	Este plugin foi desenvolvido tomando como base o Buscape 0.1 feito pelo Bruno Alves
	do www.brpoint.net com uma alteração feita pelo Cardoso do www.contraditorium.com
	Ative-o no admin do Wordpress e configure-o em Opções -> Buscapé
*/

// Definição de opções default [configuráveis]
$BP_Options = array (
	// Número de Afiliado Buscapé 
	"BP_Aff" => "1235477",

	// Texto que abre e fecha a lista de links 
	"BP_preReplace" => '<p>Compare Pre&ccedil;os de: ',
	"BP_postReplace" => ' no Buscapé.</p>',
	
	// Lista de termos utilizados quando não houver definição no post [default]
	"BP_defLists" => array (
						"MP3, iPod, celulares, notebooks, câmeras",
						"DVD, MP3, LCD, Plasma, HDTV, Home Theater",
						"games, PS2, PS3, Nintendo, Wii, iPod"
					 ),

	// Definições de comportamento
	"BP_openWindow" => "1",
	"BP_showBPinloco" => "1",
	"BP_showBPinBL" => "0",
	"BP_showDefBL" => "1",
	"BP_inPosts" => "1",
	"BP_inPages" => "1",
	"BP_inFeeds" => "1",
	// Analytics
	"BP_mapClicks" => "1",
	"BP_mapFolder" => "buscape"	
	);

// -----------------------------------------------------------------------------------------
// Não edite nada após essa linha (a menos que saiba o que está fazendo)
// -----------------------------------------------------------------------------------------


function BP_Start() {
	global $BP_Options, $BP_URL;
	$Options = get_option('BP_Options');
	if (!$Options) add_option('BP_Options', $BP_Options);
	else $BP_Options = $Options;
	
	$BP_URL = "http://busca.buscape.com.br/cprocura?lkout=1&site_origem=".$BP_Options["BP_Aff"]."&produto=";
}

function BP_Clean($text) {
    $bp_pattern = '/(\[BP\](.*?)\[\/BP\])/i';
    $bps_pattern = '/((?:<p>)?\s*\[BL\](.*?)\[\/BL\]\s*(?:<\/p>)?)/i'; 
	$text = preg_replace($bp_pattern, "$2", $text);
	return $text;
}

function BPEW($text) {
	global $BP_Options, $BP_URL;
    
	if ((is_home()||is_single())&&!$BP_Options["BP_inPosts"]) return BP_Clean($text);
	if (is_page()&&!$BP_Options["BP_inPages"]) return BP_Clean($text);
	if (is_feed()&&!$BP_Options["BP_inFeeds"]) return BP_Clean($text);
	
    $bp_pattern = '/(\[BP\](.*?)\[\/BP\])/i';
    $bps_pattern = '/((?:<p>)?\s*\[BL\](.*?)\[\/BL\]\s*(?:<\/p>)?)/i'; 
    
    $bps_count = 0;       
    $bplist_exists = 0; 
	
	$target = $BP_Options["BP_openWindow"]?"target=\"_blank\"":"";
	
	// Adiciona uma lista default randomica? A lista existe?
	if ($BP_Options["BP_showDefBL"] && $BP_Options["BP_defLists"]) {
		$BP_defLists = $BP_Options["BP_defLists"];
		$maxIndex = sizeof($BP_defLists);
		$randIndex = rand(0, $maxIndex-1);
		$listaBP = "<p>[BL]".$BP_defLists[$randIndex]."[/BL]</p>";
		$text .= (!preg_match ($bps_pattern, $text, $matches))?($listaBP):("");
	}

    # Verifica a presença das tags [BP] [/BP] no texto
    if (preg_match_all ($bp_pattern, $text, $matches)) {
        unset($bptags);
        $bptags = $BP_Options["BP_preReplace"];
		$mapFolder = $BP_Options["BP_mapClicks"]?$BP_Options["BP_mapFolder"]:false;
        for ($m=0; $m<count($matches[0]); $m++) {
            unset($mtags);
            $mtags = explode(",", $matches[2][$m]);
			$bpLink = "";
            for ($i=0; $i<count($mtags); $i++) {
				$bpLink .= '<a href="' . $BP_URL . urlencode(trim($mtags[$i])) . '" rel="external nofollow" ' .$target ." ".($mapFolder?"onClick=\"urchinTracker('/$mapFolder/".urlencode(trim($mtags[$i]))."');\"":"")." >" . trim($mtags[$i]) . '</a>';
                if ($i<count($mtags)-1) {$bpLink.= ", "; }
                $bps_count++;
            }
			$bptags .= $BP_Options["BP_showBPinBL"]?$bpLink:"";
			if ($BP_Options["BP_showBPinloco"]) 
				$text = str_replace($matches[0][$m],$bpLink,$text);
			else
				$text = str_replace($matches[0][$m],$matches[2][$m],$text);
				
            $bptags.= ($m<count($matches[0])-1 && $BP_Options["BP_showBPinBL"])?", ":"";
        } 
    }
    
    # Check for [BL] [/BL]
    if (preg_match ($bps_pattern, $text, $matches)) {
        $bplist_exists = 1;
		$mapFolder = $BP_Options["BP_mapClicks"]?$BP_Options["BP_mapFolder"]:false;
        if ($bps_count==0 || !$BP_Options["BP_showBPinBL"]) { 
            $bptags = $BP_Options["BP_preReplace"];
        } else { 
            $bptags .= ", "; 
        }
        
        unset($mtags);
        $mtags = explode(",", $matches[2]);
        for ($i=0; $i<count($mtags); $i++) {
			$bptags .= '<a href="' . $BP_URL . urlencode(trim($mtags[$i])) . '" rel="external nofollow" ' .$target ." ".($mapFolder?"onClick=\"urchinTracker('/$mapFolder/".urlencode(trim($mtags[$i]))."');\"":"")." >" . trim($mtags[$i]) . '</a>';
            if ($i<count($mtags)-1) { $bptags .= ", "; }
            $bps_count += 1;
        }
    }
    
    # If tags were found, include them in the post
    if ($bps_count>0) {
        $bptags .= $BP_Options["BP_postReplace"];
        if ($bplist_exists == 1) { 
            $text = preg_replace($bps_pattern,$bptags,$text); 
        } else {
            $text .= $bptags;
        }
    }
    return $text;
}

// Adiciona a opção no menu Options
function BP_addOptionsPage() {
		add_options_page('Op&ccedil;&otilde;es do Buscap&eacute; Everywhere', 'Buscap&eacute;', 'manage_options', basename(__FILE__), 'BP_optionsPanel');
}

// Tela do Painel
function BP_optionsPanel() {
  global $BP_Options;
  if (isset($_POST['BP_Updt'])) {
	$BP_Options["BP_Aff"] = $_POST["BP_Aff"];
	$BP_Options["BP_preReplace"] = $_POST["BP_preReplace"];
	$BP_Options["BP_postReplace"] = $_POST["BP_postReplace"];
	$BP_Options["BP_defLists"] = explode("\n", $_POST["BP_defLists"]);
	$BP_Options["BP_showBPinloco"] = $_POST["BP_showBPinloco"]?"1":"0";
	$BP_Options["BP_showBPinBL"] = $_POST["BP_showBPinBL"]?"1":"0";
	$BP_Options["BP_showDefBL"] = $_POST["BP_showDefBL"]?"1":"0";
	$BP_Options["BP_inPosts"] = $_POST["BP_inPosts"]?"1":"0";
	$BP_Options["BP_inPages"] = $_POST["BP_inPages"]?"1":"0";
	$BP_Options["BP_inFeeds"] = $_POST["BP_inFeeds"]?"1":"0";
	$BP_Options["BP_openWindow"] = $_POST["BP_openWindow"]?"1":"0";
	$BP_Options["BP_mapClicks"] = $_POST["BP_mapClicks"]?"1":"0";
	$BP_Options["BP_mapFolder"] = $_POST["BP_mapFolder"];
    update_option('BP_Options', $BP_Options);
    ?>
    <div class="updated">
      <p>
        <strong>
          Dados atualizados com sucesso.
        </strong>
      </p>
    </div>
    <?php
  }
  ?>
  <style type="text/css">
  <!--
  label { display:block; width:140px; margin-right:20px; font-size:11pt; float:left; }
  //-->
  </style>
  <div class="wrap">
    <h2>Buscapé Everywhere</h2>
      <form method="post">
        <fieldset class="options">
          <label for="BP_Aff">Código de Afiliado </label>
          <input name="BP_Aff" type="text" id="BP_Aff" value="<?=$BP_Options['BP_Aff'];?>" size="25" maxlength="25" />
          <br />
		  <p><strong>Configurações de Exibição da Listagem</strong><br />
          <label for="BP_preReplace">Texto antes</label>
          <input name="BP_preReplace" type="text" id="BP_preReplace" value="<?=$BP_Options['BP_preReplace'];?>" size="50" maxlength="50" />
          <br />
          <label for="BP_postReplace">Texto depois</label>
          <input name="BP_postReplace" type="text" id="BP_postReplace" value="<?=$BP_Options['BP_postReplace'];?>" size="50" maxlength="50" />
          <br />
          <input type="checkbox" name="BP_showBPinloco" value="1" <?=$BP_Options['BP_showBPinloco']==1?"checked=\"checked\"":"";?>/>
          Exibir links do Buscapé dentro do texto [inline]<br />
          <input type="checkbox" name="BP_showBPinBL" value="1"  <?=$BP_Options['BP_showBPinBL']==1?"checked=\"checked\"":"";?>/>
          Exibir links do Buscapé no fim do texto, em forma de lista<br />
          <input type="checkbox" name="BP_showDefBL" value="1"  <?=$BP_Options['BP_showDefBL']==1?"checked=\"checked\"":"";?>/>
          Exibir lista de links pré-definida em textos sem links presentes</p>
		  <p><strong>Seções de Exibição da Listagem</strong><br />
	  	  <input name="BP_inPosts" type="checkbox" id="BP_inPosts" value="1"  <?=$BP_Options['BP_inPosts']==1?"checked=\"checked\"":"";?>/>
				Exibir nos Posts<br />
		  		<input name="BP_inPages" type="checkbox" id="BP_inPages" value="1"  <?=$BP_Options['BP_inPages']==1?"checked=\"checked\"":"";?>/>
				Exibir nas Páginas<br />
		  		<input name="BP_inFeeds" type="checkbox" id="BP_inFeeds" value="1"  <?=$BP_Options['BP_inFeeds']==1?"checked=\"checked\"":"";?>/>
			Exibir nos Feeds</p>
		  <p><strong>Lista de links pré-definida</strong><br />
		  	Separe as palavras com &quot;,&quot;. Para randomizar, crie listas diferentes separando com &lt;enter&gt; <br />
		  	<textarea name="BP_defLists" cols="70" rows="4" id="BP_defLists"><?=implode("\n",$BP_Options['BP_defLists']);?></textarea>
		  </p>
		  <p><strong>Configurações Avançadas</strong><br />
		  	<input type="checkbox" name="BP_openWindow" value="1" <?=$BP_Options['BP_openWindow']==1?"checked=\"checked\"":"";?>/>
		  	Abrir link em nova janela (usando &quot;target=_blank&quot;)<br />
		  	<input type="checkbox" name="BP_mapClicks" value="1" <?=$BP_Options['BP_mapClicks']==1?"checked=\"checked\"":"";?>/>
		  	Mapear clicks com o Google Analytics. Pasta 
	  	   	<input name="BP_mapFolder" type="text" id="BP_mapFolder" value="<?=$BP_Options['BP_mapFolder'];?>" size="30" maxlength="30" />
		  [<a href="http://www.tecnocracia.com.br/arquivos/mapeando-cliques-e-buscas-com-o-analytics">o que é isso?</a>] </p>
		  <div class="submit" style="text-align: left;margin-top:10px">
            <input type="submit" name="BP_Updt" value="Atualizar" />
          </div>
        </fieldset>
      </form>
  </div>
<?php
}

// Actions and Filters
// ---------------------------------------------
add_action('init', 'BP_Start');
add_action('admin_menu', 'BP_addOptionsPage');
add_filter('the_content', 'BPEW');
?>